import { ModelFactory, RecordClass, RecordFactory, Table, TableRecord, TableSchema } from "./types";
export declare const createRecordModelClass: (Base: RecordClass) => {
    new (id: string, table: Table<TableRecord<any>>): {
        _fields: {
            [key: string]: any;
        };
        id: string;
        table: Table<TableRecord<any>>;
        value: any;
        update(data: Partial<any>): any;
        delete(): void;
    };
};
export declare class RecordModelFactory {
    private _recordClass;
    private _recordBaseType;
    private _factory;
    constructor(recordBaseType: RecordClass, factory: ModelFactory);
    newRecordModel(id: string, table: Table): TableRecord<any>;
    protected createRecordModel(schema: TableSchema): RecordClass;
    private _newRecordField;
    private _newRecordSet;
    private _newRecordRelation;
    private _defineProperty;
}
declare const createModelFactory: (factory: ModelFactory, RecordModel: RecordClass) => ModelFactory & RecordFactory;
export default createModelFactory;
