import { DatabaseOptions, DatabaseSchema, DatabaseState, MapOf, ModelFactory, RecordFactory, Reducer, Schema, Session, SessionOptions, TableMap, TableSchema } from "../types";
export default class Database<T extends TableMap> implements DatabaseSchema {
    schema: Schema;
    tables: TableSchema[];
    options: DatabaseOptions;
    factory: ModelFactory & RecordFactory;
    tableMap: MapOf<TableSchema>;
    constructor(schema: Schema, factory: ModelFactory & RecordFactory, options?: DatabaseOptions);
    getRecordNormalizer: (schemaName: string) => import("../types").RecordNormalizer | undefined;
    getPkGenerator: (schemaName: string) => import("../types").PkGenerator | undefined;
    getRecordComparer: (schemaName: string) => import("../types").RecordComparer | undefined;
    getRecordMerger: (schemaName: string) => import("../types").RecordMerger | undefined;
    combineReducers(...reducers: Reducer[]): (state: any, action: any) => MapOf<import("../types").TableState<any>>;
    reduce(state?: DatabaseState, action?: any, reducers?: Reducer | Reducer[], ...args: any[]): MapOf<import("../types").TableState<any>>;
    createSession(state?: DatabaseState, options?: SessionOptions): Session<T>;
    getTableSchema(name: string): TableSchema;
    selectTables(state: any): T;
    selectTable(tableState: any, schemaName?: string): import("../types").Table<import("../types").TableRecord<any>>;
}
