"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../utils");
var DbNormalizeContext = /** @class */ (function () {
    function DbNormalizeContext(schema, options) {
        this.output = {};
        this.emits = {};
        this.schema = utils_1.ensureParamObject("schema", schema, "db");
        this.db = utils_1.ensureParamObject("schema.db", this.schema.db);
        this.table = options.table;
        this.normalizePKs = options.normalizePKs === true;
        this.argument = options.argument;
    }
    DbNormalizeContext.prototype.emit = function (tableName, record) {
        this.emits[tableName] = this.emits[tableName] || [];
        this.emits[tableName].push(record);
    };
    return DbNormalizeContext;
}());
exports.default = DbNormalizeContext;
