import { FieldSchema, PartialValues, Table, TableRecord, TableRecordSet, Values } from "../types";
export default class RecordSetModel<R extends TableRecord> implements TableRecordSet<R> {
    readonly table: Table<R>;
    readonly schema: FieldSchema;
    readonly owner: {
        id: string;
    };
    constructor(table: Table<R>, schema: FieldSchema, owner: {
        id: string;
    });
    readonly ids: string[];
    readonly length: number;
    all(): R[];
    values(): import("../types").ValueType<R>[];
    add(data: Values<R>): string[];
    remove(data: PartialValues<R>): number;
    update(data: PartialValues<R>): string[];
    delete(): void;
    private _normalize;
}
